#!/usr/bin/env python

import sys

# test vas skalad 30%: 
# 1.0-> vase
# 4.6 ->normal
# 7.8 vase
# 29.4 normal
# 34.4 vase
# 38.6 vase
# 46 vase
# 50.4 normal
# 55 (slut)

utlines=[]

# starthojd, sluthojd = "0.35"
# gcodelistan = normallines / vmlines
# kopierar inkl. starthojd exklusive sluthojd
def kopiera_gcodeintervall(gcodelistan, starthojd, sluthojd):
    global utlines
    kopiering = 0
    nyhojd = 4
    print "kopierar: ",starthojd,sluthojd
    for line in gcodelistan:
        if ";BEFORE_LAYER_CHANGE" == line[:20]: # kan inte anvanda "in" pga far ej soka pa delstrang har
            # ;BEFORE_LAYER_CHANGE -> G92 E0.0 -> ;53.6
            nyhojd = 1
        if nyhojd == 3:
            hojd = float(line[1:-1])
            if hojd >= starthojd and kopiering == 0: 
                kopiering = 1
            if hojd >= sluthojd:
                kopiering = 2 # klar
        if starthojd == 0 and kopiering == 0: # specialfall - borja kopiera direkt
            kopiering = 1
        if kopiering == 1:
            utlines.append(line)
        nyhojd = nyhojd + 1
    return []


if len(sys.argv) != 3:
    print "Parameters <regular gcode> and <vasemode gcode> not given."
    exit()


normalfilnamn = str(sys.argv[1])
vmfilnamn = str(sys.argv[2])

print 'Infil normal: ', normalfilnamn
print 'Infil VASE: ', vmfilnamn

vmfil = open(vmfilnamn, "r")
normalfil = open(normalfilnamn, "r")



vmlines = vmfil.readlines()
normallines = normalfil.readlines()


# hitta hogsta hojden (sista svaret sparas)
nyhojd = 4
for line in normallines:
    if ";BEFORE_LAYER_CHANGE" == line[:20]: # kan inte anvanda "in" pga far ej soka pa delstrang har
        nyhojd = 1
    if nyhojd == 3:
        hogsthojd = float(line[1:-1])
    nyhojd = nyhojd + 1
print "highest: ", hogsthojd


#        hogsthojd=normallines[normallines.index(line)+2][1:]


numod = "normalmod"
nuhojd = 0.0
while nuhojd < hogsthojd:
    print "Remaining: ",nuhojd,"...",hogsthojd
    if numod == "normalmod":
        vasestart=float(input("Z-level for changing to vasemode: "))
        utlines.append("; FRIMMEL normalmod fran: "+str(nuhojd)+"..."+str(vasestart)+"\n")
# slutar pa samma niva som vase borjar -> tatt overlapp i borjan, om vasestart+0.01 ->  "korrekt" i borjan och glapp pa slutet av varvet
        kopiera_gcodeintervall(normallines, nuhojd, vasestart)
        nuhojd = vasestart
        numod = "vaslmod"
    else:
        normalstart=float(input("Z-level for changing to normal mode: "))
        utlines.append("; FRIMMEL vase-mod fran: "+str(nuhojd)+"..."+str(normalstart)+"\n")
        kopiera_gcodeintervall(vmlines, nuhojd, normalstart+0.01) # vasemod ska vara "forskjuten" -> tatt istf glapp
        nuhojd = normalstart
        numod = "normalmod"


utfilnamn="resultat.gcode"
utfil = open(utfilnamn, "w")
utfil.writelines(utlines)


